<template>
  <div id="app">
    <Ticker :currentCurrency="currency"></Ticker>
		<Searchbar :selectedCoins="selectedCoins" />
		<coin-list :currentCurrency="currency" :list="coinData" :isListReady="isListReady" />
		<div class="container">
			<Chart :coinDataArray="coinData.filter(e=>e.sparkline_7d.price.length > 0)" :currency="currency"></Chart>
		</div>
  </div>
</template>

<script>
import Axios from 'axios'
import Ticker from './components/Ticker.vue'
import Searchbar from './components/Searchbar.vue'
import CoinList from './components/CoinList.vue'
import Chart from './components/Chart.vue'

/**
 * @param name {String}
 * @param callback {Function}
 * @param currency {String}
 */
function getCoinDataAsync (name, currency, arrayToPushTo, callback) {
	Axios.get('https://api.coingecko.com/api/v3/coins/' + name + '?localization=false&tickers=true&market_data=true&community_data=false&developer_data=false&sparkline=true').then((response) => {
		const dataObject = {}
		const data = response.data
		dataObject.name = data.name
		dataObject.symbol = data.symbol
		dataObject.id = data.id
		dataObject.description = data.description.en
		dataObject.imageFilePath = data.image.small
		dataObject.priceChange = {
			current: data.market_data.current_price[currency],
			change24hPercentage: data.market_data.price_change_percentage_24h_in_currency[currency],
			change24h: data.market_data.price_change_24h_in_currency[currency],
			change7dPercentage: data.market_data.price_change_percentage_7d_in_currency[currency],
			change14dPercentage: data.market_data.price_change_percentage_14d_in_currency[currency],
			change30dPercentage: data.market_data.price_change_percentage_30d_in_currency[currency]
		}
		dataObject.sparkline_7d = data.market_data.sparkline_7d

		arrayToPushTo.push(dataObject)
		if (typeof callback === 'function') {
			callback(dataObject)
		}
	})
}

export default {
	name: 'App',
	components: {
		Searchbar,
		Ticker,
		CoinList,
		Chart
	},
	data: function () {
		return { selectedCoins: [], currency: 'usd', coinData: [], isListReady: true }
	},
	mounted: function () {
		document.title = 'CoinChecker by Waldemar and Julian'
	},
	methods: {
		updateData: function () {
			this.$data.isListReady = false
			this.$data.coinData = []
			for (const coin of this.$data.selectedCoins) {
				getCoinDataAsync(coin.id, this.$data.currency, this.$data.coinData, () => { this.$data.isListReady = true })
			}
			if (this.$data.coinData.length === 0) {
				// Wird gebraucht, da wenn die Cryptowährungen-liste leer ist, ist "isListReady" immernoch auf false gesetzt.
				this.$data.isListReady = true
			}
		}
	},
	watch: {
		selectedCoins: function (newVal) {
			this.updateData()
		}
	}
}

</script>
